--!parent

--****************************************************************************
-- @file      LSW CORE LIB: FILESYSTEM
-- @author    Valentin Schmidt
-- @version   1.0.0
--
-- @requires
-- - xtra("fileIO") - integrated into core lsw.exe!
--
-- @todo
-- - Extend width copy folder etc, use more powerful FileXtra4 instead
--****************************************************************************

----------------------------------------
-- @constructor
----------------------------------------
on new (me, tScriptDir)
  return me
end

-- TODO

----------------------------------------
-- is_folder() ?
----------------------------------------
on folderExists (me, tFolder)
  fp = xtra("fileIO").new()
  fp.openFile(tFolder, 1)
  stat = fp.status()
  fp.closeFile()
  fp = 0
  return (stat=-36) -- -36: I/O Error: item is a folder
end

----------------------------------------
-- list files in folder (files in subfolders not listed)
----------------------------------------
on folderList (me, tPath, tFullPathFlag)
  pd = the last char of _movie.path
  if the last char of tPath<>pd then put pd after tPath
  tFileList = []
  i = 0
  repeat while true
    i = i+1
    fn = getNthFileNameInFolder(tPath, i)
    if fn = EMPTY then exit repeat
    if tFullPathFlag then
      tFileList.append(tPath & fn)
    else
      tFileList.append(fn)
    end if
  end repeat
  return tFileList
end

----------------------------------------
-- 
----------------------------------------
on fileCopy (me, tSrcFile, tDestFile, tBufSize)
  if voidP(tBufSize) then tBufSize=1024*1024 -- 1 MB
  fp1 = xtra("fileIO").new()
  if not objectP(fp1) then return -1
  fp1.openFile(tSrcFile, 1)
  err = fp1.status()
  if (err) then
    fp1 = 0
    return err
  end if
  fp2 = xtra("fileIO").new()
  fp2.createFile(tDestFile)
  fp2.openFile(tDestFile, 2)
  err = fp2.status()
  if (err) then
    fp1.closeFile()
    fp1 = 0
    fp2 = 0
    return err
  end if
  fsize = fp1.getLength()
  cnt = fsize / tBufSize
  repeat with i = 1 to cnt
    buf = fp1.readByteArray(tBufSize)
    fp2.writeByteArray(buf)
  end repeat
  rest = fsize - cnt*tBufSize
  if rest>0 then
    buf = fp1.readByteArray(rest)
    fp2.writeByteArray(buf)
  end if
  fp1.closeFile()
  fp1=0
  fp2.closeFile()
  fp2=0
  return 1
end

----------------------------------------
-- 
----------------------------------------
on fileMove (me, tSrcFile, tDestFile, tBufSize)
  ok = me.fileCopy(tSrcFile, tDestFile, tBufSize)
  if ok then me.fileDelete(tSrcFile)
  return ok
end

----------------------------------------
-- deletes file
----------------------------------------
on fileDelete (me, tFile)
  fp = xtra("fileIO").new()
  fp.openFile(tFile, 0)
  err = fp.status()
  if not (err) then err = fp.delete()
  fp = 0
  return err
end

