--!parent
--!encoding=utf-8

--****************************************************************************
-- @file			LSW CORE LIB: IDLESLEEP
-- @author   	Valentin Schmidt
-- @version  	0.2
-- @requires  
-- - UIHelper.x32
-- @desc
-- Reduces "CPU-Hogging" by letting making projector sleep on idle
--****************************************************************************

global $

----------------------------------------
-- @constructor
----------------------------------------
on new (me, tScriptDir)

	-- check/load xtra
	ok = checkXtra("UIHelper")
	if not ok then
		if $.os="win" then
			openXLib(tScriptDir & "win\UIHelper")
		else
			openXLib(tScriptDir & "mac:UIHelper PPC Xtra.xtra")
		end if
		ok = checkXtra("UIHelper")
		if not ok then 
			alert("Error: Xtra UIHelper not found!")
			halt()
		end if
	end if
	
	-- arbitrary defaults
  $[#SleepTimeForeground] = 25
  $[#SleepTimeBackground] = 50
  $[#SleepTime] = $[#SleepTimeForeground]
  
  me.idleTime(20) -- 50/sec
  
	include(tScriptDir&"idle.ls")
	
	return me
end

----------------------------------------
-- 
----------------------------------------
on setSleepTime (me, foreground, background, now)
	if voidP(now) then now = foreground
	$[#SleepTimeForeground] = foreground
	$[#SleepTimeBackground] = background
	$[#SleepTime] = now
end

----------------------------------------
-- @param {integer} [ms] - in ms, not ticks!
----------------------------------------
on idleTime (me, ms)
	if voidP(ms) then return _movie.idleHandlerPeriod * 1000/60
	else _movie.idleHandlerPeriod = ms * 60 / 1000
end
