--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @file			Event Callback Detacher
-- @version  	0.2
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property _sender
property _method
property _receiver

----------------------------------------
-- @constructor
----------------------------------------
on new (me, sender, method, receiver)
	me._sender = sender
	me._method = method
	me._receiver = receiver
	return me
end

----------------------------------------
-- use 1 ms single-shot timeout to create a new thread
-- so scripting errors in callbacks don't fail silently
----------------------------------------
on _detach (me, widgetID)
	$.timer.create(1, #_call, me, TRUE)
end

----------------------------------------
-- we are detached from original thread, now handle signal
----------------------------------------
on _call (me)
	call(me._method, me._receiver, me._sender)
end
