--!parent

--****************************************************************************
-- @file			LSW CORE LIB: QTWIDGETS - QT-CONSTANTS EXTENSION
-- @author   	Valentin Schmidt
-- @version  	0.2
-- @desc      Adds predefined constants to Qt namespace (e.g. $.Qt.AlignLeft) 
-- @todo
--****************************************************************************

----------------------------------------
-- @constructor
----------------------------------------
on new (me, tScriptDir)
	
	-- see http://doc.qt.io/qt-4.8/qt.html
	
	----------------------------------------
	-- enum Qt::AlignmentFlag
	----------------------------------------
	me[#AlignLeft] = 1
	me[#AlignRight] = 2
	me[#AlignHCenter] = 4
	me[#AlignJustify] = 8
	me[#AlignAbsolute] = 16
	
	-- enum 	AnchorAttribute { AnchorName, AnchorHref }
	-- enum 	AnchorPoint { AnchorLeft, AnchorHorizontalCenter, AnchorRight, AnchorTop, AnchorVerticalCenter, AnchorBottom }
	-- enum 	ApplicationAttribute { AA_ImmediateWidgetCreation, AA_MSWindowsUseDirect3DByDefault, AA_DontShowIconsInMenus, AA_NativeWindows, ..., AA_CaptureMultimediaKeys }
	-- enum 	ArrowType { NoArrow, UpArrow, DownArrow, LeftArrow, RightArrow }
	-- enum 	AspectRatioMode { IgnoreAspectRatio, KeepAspectRatio, KeepAspectRatioByExpanding }
	-- enum 	Axis { XAxis, YAxis, ZAxis }
	-- enum 	BGMode { TransparentMode, OpaqueMode }
	-- enum 	BrushStyle { NoBrush, SolidPattern, Dense1Pattern, Dense2Pattern, ..., TexturePattern }
	-- enum 	CaseSensitivity { CaseInsensitive, CaseSensitive }
	-- enum 	CheckState { Unchecked, PartiallyChecked, Checked }
	-- enum 	ClipOperation { NoClip, ReplaceClip, IntersectClip, UniteClip }
	-- enum 	ConnectionType { AutoConnection, DirectConnection, QueuedConnection, BlockingQueuedConnection, UniqueConnection, AutoCompatConnection }
	
	----------------------------------------
	-- enum Qt::ContextMenuPolicy
	----------------------------------------
	me[#NoContextMenu] = 0 -- the widget does not feature a context menu, context menu handling is deferred to the widget's parent.
	me[#PreventContextMenu] = 4 -- the widget does not feature a context menu, and in contrast to NoContextMenu, the handling is not deferred to the widget's parent. This means that all right mouse button events are guaranteed to be delivered to the widget itself through mousePressEvent(), and mouseReleaseEvent().
	me[#DefaultContextMenu] = 1 -- the widget's QWidget::contextMenuEvent() handler is called.
	me[#ActionsContextMenu] = 2 -- the widget displays its QWidget::actions() as context menu.
	me[#CustomContextMenu] = 3 -- the widget emits the QWidget::customContextMenuRequested() signal.

	-- enum 	CoordinateSystem { DeviceCoordinates, LogicalCoordinates }
	-- enum 	Corner { TopLeftCorner, TopRightCorner, BottomLeftCorner, BottomRightCorner }
	-- enum 	CursorMoveStyle { LogicalMoveStyle, VisualMoveStyle }
	-- enum 	CursorShape { ArrowCursor, UpArrowCursor, CrossCursor, WaitCursor, ..., BitmapCursor }
	-- enum 	DateFormat { TextDate, ISODate, SystemLocaleShortDate, SystemLocaleLongDate, ..., LocalDate }
	-- enum 	DayOfWeek { Monday, Tuesday, Wednesday, Thursday, ..., Sunday }
	-- enum 	DockWidgetArea { LeftDockWidgetArea, RightDockWidgetArea, TopDockWidgetArea, BottomDockWidgetArea, AllDockWidgetAreas, NoDockWidgetArea }
	-- flags 	DockWidgetAreas
	-- enum 	DropAction { CopyAction, MoveAction, LinkAction, ActionMask, IgnoreAction, TargetMoveAction }
	-- flags 	DropActions
	-- enum 	EventPriority { HighEventPriority, NormalEventPriority, LowEventPriority }
	-- enum 	FillRule { OddEvenFill, WindingFill }
	-- enum 	FocusPolicy { TabFocus, ClickFocus, StrongFocus, WheelFocus, NoFocus }
	-- enum 	FocusReason { MouseFocusReason, TabFocusReason, BacktabFocusReason, ActiveWindowFocusReason, ..., OtherFocusReason }
	-- enum 	GestureFlag { DontStartGestureOnChildren, ReceivePartialGestures, IgnoredGesturesPropagateToParent }
	-- flags 	GestureFlags
	-- enum 	GestureState { GestureStarted, GestureUpdated, GestureFinished, GestureCanceled }
	-- enum 	GestureType { TapGesture, TapAndHoldGesture, PanGesture, PinchGesture, SwipeGesture, CustomGesture }
		
	----------------------------------------
	-- enum Qt::GlobalColor
	----------------------------------------
	me[#white] = rgb("ffffff")
	me[#black] = rgb("000000")
	me[#red] = rgb("ff0000")
	me[#darkRed] = rgb("800000")
	me[#green] = rgb("00ff00")
	me[#darkGreen] = rgb("008000")
	me[#blue] = rgb("0000ff")
	me[#darkBlue] = rgb("000080")
	me[#cyan] = rgb("00ffff")
	me[#darkCyan] = rgb("008080")
	me[#magenta] = rgb("ff00ff")
	me[#darkMagenta] = rgb("800080")
	me[#yellow] = rgb("ffff00")
	me[#darkYellow] = rgb("808000")
	me[#gray] = rgb("a0a0a4")
	me[#darkGray] = rgb("808080")
	me[#lightGray] = rgb("c0c0c0")
	
	-- enum 	HitTestAccuracy { ExactHit, FuzzyHit }
	-- enum 	ImageConversionFlag { AutoColor, ColorOnly, MonoOnly, DiffuseDither, ..., NoOpaqueDetection }
	-- flags 	ImageConversionFlags
	-- enum 	InputMethodHint { ImhNone, ImhHiddenText, ImhNoAutoUppercase, ImhPreferNumbers, ..., ImhExclusiveInputMask }
	-- flags 	InputMethodHints
	-- enum 	InputMethodQuery { ImMicroFocus, ImFont, ImCursorPosition, ImSurroundingText, ..., ImAnchorPosition }
	
	----------------------------------------
	-- enum Qt::ItemDataRole
	----------------------------------------
	me[#DisplayRole] = 0 -- The key data to be rendered in the form of text. (QString)
	me[#DecorationRole] = 1 -- The data to be rendered as a decoration in the form of an icon. (QColor, QIcon or QPixmap)
	me[#EditRole] = 2 -- The data in a form suitable for editing in an editor. (QString)
	me[#ToolTipRole] = 3 -- The data displayed in the item's tooltip. (QString)
	me[#StatusTipRole] = 4 -- The data displayed in the status bar. (QString)
	me[#WhatsThisRole] = 5 -- The data displayed for the item in "What's This?" mode. (QString)
	me[#SizeHintRole] = 13 -- The size hint for the item that will be supplied to views. (QSize)
	-- ...
	me[#UserRole] = 32 -- The first role that can be used for application-specific purposes.

	-- enum 	ItemFlag { NoItemFlags, ItemIsSelectable, ItemIsEditable, ItemIsDragEnabled, ..., ItemIsTristate }
	
	----------------------------------------
	-- flags Qt::ItemFlags
	----------------------------------------
	me[#NoItemFlags] = 0 -- It does not have any properties set.
	me[#ItemIsSelectable] = 1 -- It can be selected.
	me[#ItemIsEditable] = 2 -- It can be edited.
	me[#ItemIsDragEnabled] = 4 -- It can be dragged.
	me[#ItemIsDropEnabled] = 8 -- It can be used as a drop target.
	me[#ItemIsUserCheckable] = 16 -- It can be checked or unchecked by the user.
	me[#ItemIsEnabled] = 32 -- The user can interact with the item.
	me[#ItemIsTristate] = 64 -- The item is checkable with three separate states.

	-- enum 	ItemSelectionMode { ContainsItemShape, IntersectsItemShape, ContainsItemBoundingRect, IntersectsItemBoundingRect }
	-- enum 	Key { Key_Escape, Key_Tab, Key_Backtab, Key_Backspace, ..., Key_Cancel }
	
	----------------------------------------
	-- enum Qt::KeyboardModifier
	----------------------------------------
	me[#NoModifier] = 0 --	No modifier key is pressed.
	me[#ShiftModifier] = 33554432 --	A Shift key on the keyboard is pressed.
	me[#ControlModifier] = 67108864 --	A Ctrl key on the keyboard is pressed.
	me[#AltModifier] = 134217728 --	An Alt key on the keyboard is pressed.
	me[#MetaModifier] = 268435456 --	A Meta key on the keyboard is pressed.
	me[#KeypadModifier] = 536870912 --	A keypad button is pressed.

	-- flags 	KeyboardModifiers
	-- enum 	LayoutDirection { LeftToRight, RightToLeft, LayoutDirectionAuto }
	-- enum 	MaskMode { MaskInColor, MaskOutColor }
	-- enum 	MatchFlag { MatchExactly, MatchFixedString, MatchContains, MatchStartsWith, ..., MatchRecursive }
	-- flags 	MatchFlags
	
	----------------------------------------
	-- enum Qt::Modifier
	----------------------------------------
	me[#SHIFT] = me.ShiftModifier --	The Shift keys provided on all standard keyboards.
	me[#META] = me.MetaModifier --	The Meta keys.
	me[#CTRL] = me.ControlModifier --	The Ctrl keys.
	me[#ALT] = me.AltModifier --	The normal Alt keys, but not keys like AltGr.
	me[#UNICODE_ACCEL] = 0 --	The shortcut is specified as a Unicode code point, not as a Qt Key.

	-- enum 	MouseButton { NoButton, LeftButton, RightButton, MidButton, ..., XButton2 }
	-- flags 	MouseButtons
	-- enum 	NavigationMode { NavigationModeNone, NavigationModeKeypadTabOrder, NavigationModeKeypadDirectional, NavigationModeCursorAuto, NavigationModeCursorForceVisible }
	-- enum 	Orientation { Horizontal, Vertical }
	-- flags 	Orientations
	-- enum 	PenCapStyle { FlatCap, SquareCap, RoundCap }
	-- enum 	PenJoinStyle { MiterJoin, BevelJoin, RoundJoin, SvgMiterJoin }
	-- enum 	PenStyle { NoPen, SolidLine, DashLine, DotLine, ..., CustomDashLine }
	-- enum 	ScrollBarPolicy { ScrollBarAsNeeded, ScrollBarAlwaysOff, ScrollBarAlwaysOn }
	-- enum 	ShortcutContext { WidgetShortcut, WidgetWithChildrenShortcut, WindowShortcut, ApplicationShortcut }
	-- enum 	SizeHint { MinimumSize, PreferredSize, MaximumSize, MinimumDescent }
	-- enum 	SizeMode { AbsoluteSize, RelativeSize }
	-- enum 	SortOrder { AscendingOrder, DescendingOrder }
	-- enum 	TextElideMode { ElideLeft, ElideRight, ElideMiddle, ElideNone }
	-- enum 	TextFlag { TextSingleLine, TextDontClip, TextExpandTabs, TextShowMnemonic, ..., TextJustificationForced }
	-- enum 	TextFormat { PlainText, RichText, AutoText, LogText }
	-- enum 	TextInteractionFlag { NoTextInteraction, TextSelectableByMouse, TextSelectableByKeyboard, LinksAccessibleByMouse, ..., TextBrowserInteraction }
	-- flags 	TextInteractionFlags
	-- enum 	TileRule { StretchTile, RepeatTile, RoundTile }
	-- enum 	TimeSpec { LocalTime, UTC, OffsetFromUTC }
	
	----------------------------------------
	-- enum Qt::ToolBarArea
	----------------------------------------
	me[#LeftToolBarArea] = 1
	me[#RightToolBarArea] = 2
	me[#TopToolBarArea] = 4
	me[#BottomToolBarArea] = 8
	me[#NoToolBarArea] = 0
	
	----------------------------------------
	-- enum Qt::ToolButtonStyle
	----------------------------------------
	me[#ToolButtonIconOnly] = 0 --	Only display the icon.
	me[#ToolButtonTextOnly] = 1 --	Only display the text.
	me[#ToolButtonTextBesideIcon] = 2 --	The text appears beside the icon.
	me[#ToolButtonTextUnderIcon] = 3 --	The text appears under the icon.
	me[#ToolButtonFollowStyle] = 4 --	Follow the style.
	
	-- enum 	TouchPointState { TouchPointPressed, TouchPointMoved, TouchPointStationary, TouchPointReleased }
	-- flags 	TouchPointStates
	-- enum 	TransformationMode { FastTransformation, SmoothTransformation }
	-- enum 	UIEffect { UI_AnimateMenu, UI_FadeMenu, UI_AnimateCombo, UI_AnimateTooltip, UI_FadeTooltip, UI_AnimateToolBox }
	-- typedef 	WFlags
	-- enum 	WhiteSpaceMode { WhiteSpaceNormal, WhiteSpacePre, WhiteSpaceNoWrap }
	-- enum 	WidgetAttribute { WA_AcceptDrops, WA_AlwaysShowToolTips, WA_ContentsPropagated, WA_CustomWhatsThis, ..., WA_MacNoShadow }
	-- flags 	WindowFlags
	-- enum 	WindowFrameSection { NoSection, LeftSection, TopLeftSection, TopSection, ..., TitleBarArea }
	-- enum 	WindowModality { NonModal, WindowModal, ApplicationModal }
	
	----------------------------------------
	-- enum Qt::QWindowState
	----------------------------------------
	me[#WindowNoState] = 0 -- The window has no state set (in normal state).
	me[#WindowMinimized] = 1 -- The window is minimized (i.e. iconified).
	me[#WindowMaximized] = 2 -- The window is maximized with a frame around it.
	me[#WindowFullScreen] = 4 -- The window fills the entire screen without any frame around it.
	me[#WindowActive] = 8 -- The window is the active window, i.e. it has keyboard focus.
	
	-- enum WindowType { Widget, Window, Dialog, Sheet, ..., WMacNoSheet }


 	--**************************************
 	-- OTHER NAMESPACES
 	--**************************************

	----------------------------------------
	-- enum QAbstractItemView::DragDropMode
	----------------------------------------^
	p = [:]
	
	p[#NoDragDrop] = 0
	p[#DragOnly] = 1
	p[#DropOnly] = 2
	p[#DragDrop] = 3
	p[#InternalMove] = 4
	
	me[#QAbstractItemView] = p

	----------------------------------------
	-- enum QDialog::DialogCode
	----------------------------------------
	p = [:]
	
	p[#Accepted] = 1
	p[#Rejected] = 0
	
	me[#QDialog] = p
	
	----------------------------------------
	-- enum QDockWidget::DockWidgetFeature
	----------------------------------------
	p = [:]
	
	p[#DockWidgetClosable] = 1
	p[#DockWidgetMovable] = 2
	p[#DockWidgetFloatable] = 4
	p[#DockWidgetVerticalTitleBar] = 8
	
	me[#QDockWidget] = p
	
	----------------------------------------
	-- enum QFont::Weight
	----------------------------------------
	p = [:]
		
	p[#Light] = 25
	p[#Normal] = 50
	p[#DemiBold] = 63
	p[#Bold] = 75
	p[#Black] = 87
	
	me[#QFont] = p
	
	----------------------------------------
	-- enum QKeySequence:StandardKey
	----------------------------------------
	p = [:]
	
	p[#AddTab] = 19 -- Add new tab.
	p[#Back] = 13 -- Navigate back.
	p[#Bold] = 27 -- Bold text.
	p[#Close] = 4 -- Close document/tab.
	p[#Copy] = 9 -- Copy.
	p[#Cut] = 8 -- Cut.
	p[#Delete] = 7 -- Delete.
	p[#DeleteEndOfLine] = 60 -- Delete end of line.
	p[#DeleteEndOfWord] = 59 -- Delete word from the end of the cursor.
	p[#DeleteStartOfWord] = 58 -- Delete the beginning of a word up to the cursor.
	p[#Find] = 22 -- Find in document.
	p[#FindNext] = 23 -- Find next result.
	p[#FindPrevious] = 24 -- Find previous result.
	p[#Forward] = 14 -- Navigate forward.
	p[#HelpContents] = 1 -- Open help contents.
	p[#InsertLineSeparator] = 62 -- Insert a new line.
	p[#InsertParagraphSeparator] = 61 -- Insert a new paragraph.
	p[#Italic] = 28 -- Italic text.
	p[#MoveToEndOfBlock] = 41 -- Move cursor to end of block. This shortcut is only used on the OS X.
	p[#MoveToEndOfDocument] = 43 -- Move cursor to end of document.
	p[#MoveToEndOfLine] = 39 -- Move cursor to end of line.
	p[#MoveToNextChar] = 30 -- Move cursor to next character.
	p[#MoveToNextLine] = 34 -- Move cursor to next line.
	p[#MoveToNextPage] = 36 -- Move cursor to next page.
	p[#MoveToNextWord] = 32 -- Move cursor to next word.
	p[#MoveToPreviousChar] = 31 -- Move cursor to previous character.
	p[#MoveToPreviousLine] = 35 -- Move cursor to previous line.
	p[#MoveToPreviousPage] = 37 -- Move cursor to previous page.
	p[#MoveToPreviousWord] = 33 -- Move cursor to previous word.
	p[#MoveToStartOfBlock] = 40 -- Move cursor to start of a block. This shortcut is only used on OS X.
	p[#MoveToStartOfDocument] = 42 -- Move cursor to start of document.
	p[#MoveToStartOfLine] = 38 -- Move cursor to start of line.
	p[#New] = 6 -- Create new document.
	p[#NextChild] = 20 -- Navigate to next tab or child window.
	p[#Open] = 3 -- Open document.
	p[#Paste] = 10 -- Paste.
	p[#Preferences] = 64 -- Open the preferences dialog.
	p[#PreviousChild] = 21 -- Navigate to previous tab or child window.
	p[#Print] = 18 -- Print document.
	p[#Quit] = 65 -- Quit the application.
	p[#Redo] = 12 -- Redo.
	p[#Refresh] = 15 -- Refresh or reload current document.
	p[#Replace] = 25 -- Find and replace.
	p[#SaveAs] = 63 -- Save document after prompting the user for a file name.
	p[#Save] = 5 -- Save document.
	p[#SelectAll] = 26 -- Select all text.
	p[#SelectEndOfBlock] = 55 -- Extend selection to the end of a text block. This shortcut is only used on OS X.
	p[#SelectEndOfDocument] = 57 -- Extend selection to end of document.
	p[#SelectEndOfLine] = 53 -- Extend selection to end of line.
	p[#SelectNextChar] = 44 -- Extend selection to next character.
	p[#SelectNextLine] = 48 -- Extend selection to next line.
	p[#SelectNextPage] = 50 -- Extend selection to next page.
	p[#SelectNextWord] = 46 -- Extend selection to next word.
	p[#SelectPreviousChar] = 45 -- Extend selection to previous character.
	p[#SelectPreviousLine] = 49 -- Extend selection to previous line.
	p[#SelectPreviousPage] = 51 -- Extend selection to previous page.
	p[#SelectPreviousWord] = 47 -- Extend selection to previous word.
	p[#SelectStartOfBlock] = 54 -- Extend selection to the start of a text block. This shortcut is only used on OS X.
	p[#SelectStartOfDocument] = 56 -- Extend selection to start of document.
	p[#SelectStartOfLine] = 52 -- Extend selection to start of line.
	p[#Underline] = 29 -- Underline text.
	p[#Undo] = 11 -- Undo.
	p[#UnknownKey] = 0 -- Unbound key.
	p[#WhatsThis] = 2 -- Activate whats this.
	p[#ZoomIn] = 16 -- Zoom in.
	p[#ZoomOut] = 17 -- Zoom out.
	
	me[#QKeySequence] = p
	
	----------------------------------------
	-- enum QLineEdit::EchoMode
	----------------------------------------
	p = [:]
	
	p[#Normal] = 0
	p[#NoEcho] = 1
	p[#Password] = 2
	p[#PasswordEchoOnEdit] = 3

	me[#QLineEdit] = p

	----------------------------------------
	-- enum QMessageBox::StandardButton
	----------------------------------------
	p = [:]
	
	p[#Ok] = 1024
	p[#Open] = 8192
	p[#Save] = 2048
	p[#Cancel] = 4194304
	p[#Close] = 2097152
	p[#Discard] = 8388608
	
	me[#QMessageBox] = p

	----------------------------------------
	-- enum QPrinter::OutputFormat
	----------------------------------------
	p = [:]
	
	p[#NativeFormat] = 0
	p[#PdfFormat] = 1
	p[#PostScriptFormat] = 2

	----------------------------------------
	-- enum QPrinter::PrinterMode
	----------------------------------------

	p[#ScreenResolution] = 0
	p[#PrinterResolution] = 1
	p[#HighResolution] = 2
	
	me[#QPrinter] = p
	
	----------------------------------------
	-- enum QsciScintilla::BraceMatch
	----------------------------------------
	p = [:]
	
	p[#NoBraceMatch] = 0
	p[#StrictBraceMatch] = 1
	p[#SloppyBraceMatch] = 2
	
	----------------------------------------
	-- enum QsciScintilla::FoldStyle
	----------------------------------------
	
	p[#NoFoldStyle] = 0
	p[#PlainFoldStyle] = 1
	p[#CircledFoldStyle] = 2
	p[#BoxedFoldStyle] = 3
	p[#CircledTreeFoldStyle] = 4
	p[#BoxedTreeFoldStyle] = 5
	
	me[#QsciScintilla] = p	
	
	----------------------------------------
	-- enum QSettings::Format
	----------------------------------------
	p = [:]
	
	p[#NativeFormat] = 0
	p[#IniFormat] = 1
	
	me[#QSettings] = p	
	
	----------------------------------------
	-- enum QSizePolicy::Policy
	----------------------------------------
	p = [:]
	
	p[#Fixed] = 0
	
	p[#GrowFlag] = 1
	p[#ExpandFlag] = 2
	p[#ShrinkFlag] = 4
	p[#IgnoreFlag] = 8
	
	me[#QSizePolicy] = p	
		
	----------------------------------------
	-- enum QTextListFormat::Style
	----------------------------------------
	p = [:]
	
	p[#ListDisc] = -1
	p[#ListCircle] = -2
	p[#ListSquare] = -3
	p[#ListDecimal] = -4
	p[#ListLowerAlpha] = -5
	p[#ListUpperAlpha] = -6
	p[#ListLowerRoman] = -7
	p[#ListUpperRoman] = -8
	
	me[#QTextListFormat] = p
	
	----------------------------------------
	-- enum QWebSettings::WebAttribute
	----------------------------------------
	p = [:]
	
	p[#AutoLoadImages] = 0
	p[#JavascriptEnabled] = 1
	p[#JavaEnabled] = 2
	p[#PluginsEnabled] = 3
	p[#PrivateBrowsingEnabled] = 4
	p[#JavascriptCanOpenWindows] = 5
	p[#JavascriptCanAccessClipboard] = 6
	p[#DeveloperExtrasEnabled] = 7
	p[#LinksIncludedInFocusChain] = 8
	p[#ZoomTextOnly] = 9
	p[#PrintElementBackgrounds] = 10
	p[#OfflineStorageDatabaseEnabled] = 11
	p[#OfflineWebApplicationCacheEnabled] = 12
	p[#LocalStorageEnabled] = 13
	
	me[#QWebSettings] = p
	
	return me
end